package B4A.SQLExample;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "B4A.SQLExample", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "B4A.SQLExample", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _rowcol{
boolean IsInitialized;
int Row;
int Col;
public void Initialize() {
IsInitialized = true;
Row = 0;
Col = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static String _progname = "";
public static String _progversion = "";
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static String _dbfilename = "";
public static String _dbfiledir = "";
public static String _dbtablename = "";
public static int _numberofcolumns = 0;
public static int _numberofrows = 0;
public static int _numberofvisiblerows = 0;
public static int _rowheight = 0;
public static int _rowlinewidth = 0;
public static int _rowheight_1 = 0;
public static int _collinewidth = 0;
public static int[] _columnwidth = null;
public static int[] _columnwidth_1 = null;
public static int[] _totalcolumnwidth = null;
public static String[] _columnname = null;
public static String _columntosort = "";
public static boolean _filter = false;
public static String _filtertype = "";
public static String[] _sortdirection = null;
public static int _headercolor = 0;
public static int _headerfontcolor = 0;
public static int _headerlinecolor = 0;
public static int _linecolor = 0;
public static int _cellcolor = 0;
public static int _fontcolor = 0;
public static float _fontsize = 0f;
public static int _alignment = 0;
public static int _selectedrow = 0;
public static int _selectedrowcolor = 0;
public static int _selectedcellcolor = 0;
public static float _moveleft0 = 0f;
public static float _movex0 = 0f;
public static float _movex1 = 0f;
public static float _deltascroll = 0f;
public static float _deltax = 0f;
public static long _time0 = 0L;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvpersons = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvedit = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvfilter = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnltoolbox = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnledit = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnledittools = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlfilter = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlfiltertools = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btneditadd = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndelete = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnedit = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btneditmodif = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btneditmove = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnload = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfilter = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfiltergo = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfilterand = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfilteror = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfiltertype = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlheader = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _skbscroll = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlscroll = null;
public anywheresoftware.b4a.objects.Timer _timer1 = null;
public static float _lheight = 0f;
public static float _eheight = 0f;
public static float _theight = 0f;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 75;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1024);
 BA.debugLineNum = 76;BA.debugLine="Dim i As Int";
Debug.ShouldStop(2048);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 78;BA.debugLine="Activity.LoadLayout(\"Main\")";
Debug.ShouldStop(8192);
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 BA.debugLineNum = 81;BA.debugLine="pnlToolBox.Top = Activity.Height - pnlToolBox.Height";
Debug.ShouldStop(65536);
mostCurrent._pnltoolbox.setTop((int)(mostCurrent._activity.getHeight()-mostCurrent._pnltoolbox.getHeight()));
 BA.debugLineNum = 83;BA.debugLine="pnlScroll.Top = pnlToolBox.Top - pnlScroll.Height";
Debug.ShouldStop(262144);
mostCurrent._pnlscroll.setTop((int)(mostCurrent._pnltoolbox.getTop()-mostCurrent._pnlscroll.getHeight()));
 BA.debugLineNum = 84;BA.debugLine="pnlScroll.Color = Colors.Blue";
Debug.ShouldStop(524288);
mostCurrent._pnlscroll.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 86;BA.debugLine="skbScroll.Top = pnlToolBox.Top - skbScroll.Height";
Debug.ShouldStop(2097152);
mostCurrent._skbscroll.setTop((int)(mostCurrent._pnltoolbox.getTop()-mostCurrent._skbscroll.getHeight()));
 BA.debugLineNum = 87;BA.debugLine="skbScroll.Visible = True";
Debug.ShouldStop(4194304);
mostCurrent._skbscroll.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 89;BA.debugLine="scvPersons.Top = RowHeight";
Debug.ShouldStop(16777216);
mostCurrent._scvpersons.setTop(_rowheight);
 BA.debugLineNum = 92;BA.debugLine="scvPersons.Height = pnlScroll.Top - RowHeight";
Debug.ShouldStop(134217728);
mostCurrent._scvpersons.setHeight((int)(mostCurrent._pnlscroll.getTop()-_rowheight));
 BA.debugLineNum = 93;BA.debugLine="scvPersons.Panel.Color = LineColor";
Debug.ShouldStop(268435456);
mostCurrent._scvpersons.getPanel().setColor(_linecolor);
 BA.debugLineNum = 96;BA.debugLine="pnlEdit.Initialize(\"\")";
Debug.ShouldStop(-2147483648);
mostCurrent._pnledit.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 97;BA.debugLine="Activity.AddView(pnlEdit,0,0,100%x,100%y)";
Debug.ShouldStop(1);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnledit.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 98;BA.debugLine="pnlEdit.LoadLayout(\"Edit\")";
Debug.ShouldStop(2);
mostCurrent._pnledit.LoadLayout("Edit",mostCurrent.activityBA);
 BA.debugLineNum = 99;BA.debugLine="scvEdit.ScrollPosition = 0";
Debug.ShouldStop(4);
mostCurrent._scvedit.setScrollPosition((int)(0));
 BA.debugLineNum = 100;BA.debugLine="pnlEdit.Visible = False";
Debug.ShouldStop(8);
mostCurrent._pnledit.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 103;BA.debugLine="pnlFilter.Initialize(\"\")";
Debug.ShouldStop(64);
mostCurrent._pnlfilter.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 104;BA.debugLine="Activity.AddView(pnlFilter,0,0,100%x,100%y)";
Debug.ShouldStop(128);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlfilter.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 105;BA.debugLine="pnlFilter.LoadLayout(\"Filter\")";
Debug.ShouldStop(256);
mostCurrent._pnlfilter.LoadLayout("Filter",mostCurrent.activityBA);
 BA.debugLineNum = 106;BA.debugLine="scvFilter.ScrollPosition = 0";
Debug.ShouldStop(512);
mostCurrent._scvfilter.setScrollPosition((int)(0));
 BA.debugLineNum = 107;BA.debugLine="pnlFilter.Visible = False";
Debug.ShouldStop(1024);
mostCurrent._pnlfilter.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 110;BA.debugLine="TotalColumnWidth(0) = ColLineWidth";
Debug.ShouldStop(8192);
_totalcolumnwidth[(int)(0)] = _collinewidth;
 BA.debugLineNum = 111;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(16384);
{
final double step107 = 1;
final double limit107 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step107 > 0 && _i <= limit107) || (step107 < 0 && _i >= limit107); _i += step107) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 112;BA.debugLine="ColumnWidth_1(i) = ColumnWidth(i) - ColLineWidth";
Debug.ShouldStop(32768);
_columnwidth_1[_i] = (int)(_columnwidth[_i]-_collinewidth);
 BA.debugLineNum = 113;BA.debugLine="TotalColumnWidth(i + 1) = TotalColumnWidth(i) + ColumnWidth(i)";
Debug.ShouldStop(65536);
_totalcolumnwidth[(int)(_i+1)] = (int)(_totalcolumnwidth[_i]+_columnwidth[_i]);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 117;BA.debugLine="scvPersons.Width = TotalColumnWidth(NumberOfColumns)";
Debug.ShouldStop(1048576);
mostCurrent._scvpersons.setWidth(_totalcolumnwidth[_numberofcolumns]);
 BA.debugLineNum = 120;BA.debugLine="skbScroll.Max = scvPersons.Width - Activity.Width";
Debug.ShouldStop(8388608);
mostCurrent._skbscroll.setMax((int)(mostCurrent._scvpersons.getWidth()-mostCurrent._activity.getWidth()));
 BA.debugLineNum = 122;BA.debugLine="SelectedRow = -1		' sets the selected row index to -1";
Debug.ShouldStop(33554432);
_selectedrow = (int)(-1);
 BA.debugLineNum = 124;BA.debugLine="File.Delete(DBFileDir, DBFileName)	' used for testing, deletes the existing database";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.File.Delete(_dbfiledir,_dbfilename);
 BA.debugLineNum = 127;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(1073741824);
if (_firsttime) { 
 BA.debugLineNum = 128;BA.debugLine="If File.Exists(DBFileDir, DBFileName) = False  Then";
Debug.ShouldStop(-2147483648);
if (anywheresoftware.b4a.keywords.Common.File.Exists(_dbfiledir,_dbfilename)==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 129;BA.debugLine="File.Copy(File.DirAssets, DBFileName, DBFileDir, DBFileName)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),_dbfilename,_dbfiledir,_dbfilename);
 };
 BA.debugLineNum = 131;BA.debugLine="SQL1.Initialize(DBFileDir, DBFileName, True)";
Debug.ShouldStop(4);
_sql1.Initialize(_dbfiledir,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 134;BA.debugLine="Timer1.Initialize(\"Timer1\",100)";
Debug.ShouldStop(32);
mostCurrent._timer1.Initialize(processBA,"Timer1",(long)(100));
 BA.debugLineNum = 136;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 209;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(65536);
 BA.debugLineNum = 211;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
anywheresoftware.b4a.sql.SQL.CursorWrapper _curs = null;
 BA.debugLineNum = 138;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(512);
 BA.debugLineNum = 140;BA.debugLine="LHeight = 30dip		' Label height";
Debug.ShouldStop(2048);
_lheight = (float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 141;BA.debugLine="EHeight = 50dip		' EditText height";
Debug.ShouldStop(4096);
_eheight = (float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50)));
 BA.debugLineNum = 142;BA.debugLine="THeight = LHeight + EHeight + 10dip	' height";
Debug.ShouldStop(8192);
_theight = (float)(_lheight+_eheight+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)));
 BA.debugLineNum = 143;BA.debugLine="scvEdit.Height = 100%y - pnlEditTools.Height - 10dip";
Debug.ShouldStop(16384);
mostCurrent._scvedit.setHeight((int)(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-mostCurrent._pnledittools.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))));
 BA.debugLineNum = 144;BA.debugLine="scvEdit.Panel.Height = (NumberOfColumns - 1) * THeight + 100%y - pnlEditTools.Height - 10dip";
Debug.ShouldStop(32768);
mostCurrent._scvedit.getPanel().setHeight((int)((_numberofcolumns-1)*_theight+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-mostCurrent._pnledittools.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))));
 BA.debugLineNum = 145;BA.debugLine="scvEdit.Panel.Color = Colors.RGB(0,96,0)";
Debug.ShouldStop(65536);
mostCurrent._scvedit.getPanel().setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0),(int)(96),(int)(0)));
 BA.debugLineNum = 147;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(262144);
{
final double step130 = 1;
final double limit130 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step130 > 0 && _i <= limit130) || (step130 < 0 && _i >= limit130); _i += step130) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 148;BA.debugLine="Dim l As Label";
Debug.ShouldStop(524288);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 149;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(1048576);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 150;BA.debugLine="l.Initialize(\"\")";
Debug.ShouldStop(2097152);
_l.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 151;BA.debugLine="scvEdit.Panel.AddView(l,10dip,i * THeight,scvEdit.Width - 20dip,LHeight)";
Debug.ShouldStop(4194304);
mostCurrent._scvedit.getPanel().AddView((android.view.View)(_l.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),(int)(_i*_theight),(int)(mostCurrent._scvedit.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20))),(int)(_lheight));
 BA.debugLineNum = 152;BA.debugLine="l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL";
Debug.ShouldStop(8388608);
_l.setGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 153;BA.debugLine="l.Tag = i";
Debug.ShouldStop(16777216);
_l.setTag((Object)(_i));
 BA.debugLineNum = 154;BA.debugLine="l.TextColor = Colors.Yellow";
Debug.ShouldStop(33554432);
_l.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 BA.debugLineNum = 155;BA.debugLine="l.Text = ColumnName(l.Tag)";
Debug.ShouldStop(67108864);
_l.setText((Object)(_columnname[(int)(BA.ObjectToNumber(_l.getTag()))]));
 BA.debugLineNum = 156;BA.debugLine="e.Initialize(\"edtEdit\")";
Debug.ShouldStop(134217728);
_e.Initialize(mostCurrent.activityBA,"edtEdit");
 BA.debugLineNum = 157;BA.debugLine="scvEdit.Panel.AddView(e,5dip,i * THeight + LHeight,scvEdit.Width - 10dip,EHeight)";
Debug.ShouldStop(268435456);
mostCurrent._scvedit.getPanel().AddView((android.view.View)(_e.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),(int)(_i*_theight+_lheight),(int)(mostCurrent._scvedit.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))),(int)(_eheight));
 BA.debugLineNum = 158;BA.debugLine="e.Gravity = Gravity.LEFT";
Debug.ShouldStop(536870912);
_e.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.LEFT);
 BA.debugLineNum = 159;BA.debugLine="e.Tag = i";
Debug.ShouldStop(1073741824);
_e.setTag((Object)(_i));
 BA.debugLineNum = 160;BA.debugLine="If i = 0 Then";
Debug.ShouldStop(-2147483648);
if (_i==0) { 
 BA.debugLineNum = 161;BA.debugLine="e.Enabled = False";
Debug.ShouldStop(1);
_e.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 165;BA.debugLine="scvFilter.Height = Activity.Height - pnlFilterTools.Height - 5dip";
Debug.ShouldStop(16);
mostCurrent._scvfilter.setHeight((int)(mostCurrent._activity.getHeight()-mostCurrent._pnlfiltertools.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5))));
 BA.debugLineNum = 166;BA.debugLine="scvFilter.Panel.Height = (NumberOfColumns - 2) * THeight + 100%y - pnlFilterTools.Height - 10dip";
Debug.ShouldStop(32);
mostCurrent._scvfilter.getPanel().setHeight((int)((_numberofcolumns-2)*_theight+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-mostCurrent._pnlfiltertools.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))));
 BA.debugLineNum = 167;BA.debugLine="scvFilter.Panel.Color = Colors.RGB(0,0,128)";
Debug.ShouldStop(64);
mostCurrent._scvfilter.getPanel().setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0),(int)(0),(int)(128)));
 BA.debugLineNum = 169;BA.debugLine="For i = 1 To NumberOfColumns - 1";
Debug.ShouldStop(256);
{
final double step150 = 1;
final double limit150 = (int)(_numberofcolumns-1);
for (_i = (int)(1); (step150 > 0 && _i <= limit150) || (step150 < 0 && _i >= limit150); _i += step150) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 170;BA.debugLine="Dim l As Label";
Debug.ShouldStop(512);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 171;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(1024);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 172;BA.debugLine="l.Initialize(\"\")";
Debug.ShouldStop(2048);
_l.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 173;BA.debugLine="scvFilter.Panel.AddView(l,10dip,(i - 1) * THeight,scvFilter.Width - 20dip,LHeight)";
Debug.ShouldStop(4096);
mostCurrent._scvfilter.getPanel().AddView((android.view.View)(_l.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),(int)((_i-1)*_theight),(int)(mostCurrent._scvfilter.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20))),(int)(_lheight));
 BA.debugLineNum = 174;BA.debugLine="l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL";
Debug.ShouldStop(8192);
_l.setGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 175;BA.debugLine="l.Tag = i";
Debug.ShouldStop(16384);
_l.setTag((Object)(_i));
 BA.debugLineNum = 176;BA.debugLine="l.TextColor = Colors.Yellow";
Debug.ShouldStop(32768);
_l.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 BA.debugLineNum = 177;BA.debugLine="l.Text = ColumnName(l.Tag)";
Debug.ShouldStop(65536);
_l.setText((Object)(_columnname[(int)(BA.ObjectToNumber(_l.getTag()))]));
 BA.debugLineNum = 178;BA.debugLine="e.Initialize(\"edtFilter\")";
Debug.ShouldStop(131072);
_e.Initialize(mostCurrent.activityBA,"edtFilter");
 BA.debugLineNum = 179;BA.debugLine="scvFilter.Panel.AddView(e,5dip,(i - 1) * THeight + LHeight,scvFilter.Width - 10dip,EHeight)";
Debug.ShouldStop(262144);
mostCurrent._scvfilter.getPanel().AddView((android.view.View)(_e.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),(int)((_i-1)*_theight+_lheight),(int)(mostCurrent._scvfilter.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))),(int)(_eheight));
 BA.debugLineNum = 180;BA.debugLine="e.Gravity = Gravity.LEFT";
Debug.ShouldStop(524288);
_e.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.LEFT);
 BA.debugLineNum = 181;BA.debugLine="e.Tag = i";
Debug.ShouldStop(1048576);
_e.setTag((Object)(_i));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 184;BA.debugLine="NumberOfVisibleRows = scvPersons.Height / RowHeight";
Debug.ShouldStop(8388608);
_numberofvisiblerows = (int)(mostCurrent._scvpersons.getHeight()/(double)_rowheight);
 BA.debugLineNum = 187;BA.debugLine="If FilterType = \"AND\" Then";
Debug.ShouldStop(67108864);
if ((_filtertype).equals("AND")) { 
 BA.debugLineNum = 188;BA.debugLine="btnFilterType = btnFilterAND";
Debug.ShouldStop(134217728);
mostCurrent._btnfiltertype = mostCurrent._btnfilterand;
 }else {
 BA.debugLineNum = 190;BA.debugLine="btnFilterType = btnFilterOR";
Debug.ShouldStop(536870912);
mostCurrent._btnfiltertype = mostCurrent._btnfilteror;
 };
 BA.debugLineNum = 194;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(2);
{
final double step170 = 1;
final double limit170 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step170 > 0 && _i <= limit170) || (step170 < 0 && _i >= limit170); _i += step170) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 195;BA.debugLine="SortDirection(i) = \"ASC\"";
Debug.ShouldStop(4);
_sortdirection[_i] = "ASC";
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 198;BA.debugLine="Dim curs As Cursor";
Debug.ShouldStop(32);
_curs = new anywheresoftware.b4a.sql.SQL.CursorWrapper();Debug.locals.put("curs", _curs);
 BA.debugLineNum = 199;BA.debugLine="curs = SQL1.ExecQuery(\"SELECT name FROM sqlite_master WHERE Type='table'\")";
Debug.ShouldStop(64);
_curs.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT name FROM sqlite_master WHERE Type='table'")));
 BA.debugLineNum = 200;BA.debugLine="Log(curs.RowCount)";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_curs.getRowCount()));
 BA.debugLineNum = 201;BA.debugLine="curs.Position = 0";
Debug.ShouldStop(256);
_curs.setPosition((int)(0));
 BA.debugLineNum = 202;BA.debugLine="Log(curs.GetString(\"name\"))";
Debug.ShouldStop(512);
anywheresoftware.b4a.keywords.Common.Log(_curs.GetString("name"));
 BA.debugLineNum = 203;BA.debugLine="DBTableName = curs.GetString(\"name\")";
Debug.ShouldStop(1024);
_dbtablename = _curs.GetString("name");
 BA.debugLineNum = 205;BA.debugLine="SQLTableRead";
Debug.ShouldStop(4096);
_sqltableread();
 BA.debugLineNum = 207;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _addrow(String[] _values) throws Exception{
		Debug.PushSubsStack("AddRow (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
main._rowcol _rc = null;
Debug.locals.put("Values", _values);
 BA.debugLineNum = 274;BA.debugLine="Sub AddRow(Values() As String)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 276;BA.debugLine="If Values.Length <> NumberOfColumns Then";
Debug.ShouldStop(524288);
if (_values.length!=_numberofcolumns) { 
 BA.debugLineNum = 277;BA.debugLine="Log(\"Wrong number of values.\")";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.Log("Wrong number of values.");
 BA.debugLineNum = 278;BA.debugLine="Return";
Debug.ShouldStop(2097152);
if (true) return "";
 };
 BA.debugLineNum = 281;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(16777216);
{
final double step234 = 1;
final double limit234 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step234 > 0 && _i <= limit234) || (step234 < 0 && _i >= limit234); _i += step234) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 282;BA.debugLine="Dim l As Label";
Debug.ShouldStop(33554432);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 283;BA.debugLine="l.Initialize(\"cell\")";
Debug.ShouldStop(67108864);
_l.Initialize(mostCurrent.activityBA,"cell");
 BA.debugLineNum = 284;BA.debugLine="l.Text = Values(i)";
Debug.ShouldStop(134217728);
_l.setText((Object)(_values[_i]));
 BA.debugLineNum = 285;BA.debugLine="l.Gravity = Alignment";
Debug.ShouldStop(268435456);
_l.setGravity(_alignment);
 BA.debugLineNum = 286;BA.debugLine="l.TextSize = FontSize";
Debug.ShouldStop(536870912);
_l.setTextSize(_fontsize);
 BA.debugLineNum = 287;BA.debugLine="l.TextColor = FontColor";
Debug.ShouldStop(1073741824);
_l.setTextColor(_fontcolor);
 BA.debugLineNum = 288;BA.debugLine="l.Color=CellColor";
Debug.ShouldStop(-2147483648);
_l.setColor(_cellcolor);
 BA.debugLineNum = 289;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(1);
_rc = new main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 290;BA.debugLine="rc.Initialize";
Debug.ShouldStop(2);
_rc.Initialize();
 BA.debugLineNum = 291;BA.debugLine="rc.Col = i";
Debug.ShouldStop(4);
_rc.Col = _i;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 292;BA.debugLine="rc.Row = NumberOfRows";
Debug.ShouldStop(8);
_rc.Row = _numberofrows;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 293;BA.debugLine="l.Tag = rc";
Debug.ShouldStop(16);
_l.setTag((Object)(_rc));
 BA.debugLineNum = 294;BA.debugLine="scvPersons.Panel.AddView(l, TotalColumnWidth(i), RowHeight * NumberOfRows, _ 		ColumnWidth_1(i), RowHeight_1)";
Debug.ShouldStop(32);
mostCurrent._scvpersons.getPanel().AddView((android.view.View)(_l.getObject()),_totalcolumnwidth[_i],(int)(_rowheight*_numberofrows),_columnwidth_1[_i],_rowheight_1);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 297;BA.debugLine="NumberOfRows = NumberOfRows + 1";
Debug.ShouldStop(256);
_numberofrows = (int)(_numberofrows+1);
 BA.debugLineNum = 298;BA.debugLine="scvPersons.Panel.Height = NumberOfRows * RowHeight";
Debug.ShouldStop(512);
mostCurrent._scvpersons.getPanel().setHeight((int)(_numberofrows*_rowheight));
 BA.debugLineNum = 299;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btndelete_click() throws Exception{
		Debug.PushSubsStack("btnDelete_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _row = 0;
int _col = 0;
int _answ = 0;
int _index = 0;
int _i = 0;
 BA.debugLineNum = 451;BA.debugLine="Sub btnDelete_Click";
Debug.ShouldStop(4);
 BA.debugLineNum = 452;BA.debugLine="Dim row, col, Answ, Index As Int";
Debug.ShouldStop(8);
_row = 0;Debug.locals.put("row", _row);
_col = 0;Debug.locals.put("col", _col);
_answ = 0;Debug.locals.put("Answ", _answ);
_index = 0;Debug.locals.put("Index", _index);
 BA.debugLineNum = 453;BA.debugLine="Dim i As Int";
Debug.ShouldStop(16);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 455;BA.debugLine="Answ = Msgbox2(\"Do you really want to delete the selected row\",\"A T T E N T I O N\",\"Yes\",\"\",\"No\",Null)";
Debug.ShouldStop(64);
_answ = anywheresoftware.b4a.keywords.Common.Msgbox2("Do you really want to delete the selected row","A T T E N T I O N","Yes","","No",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA);Debug.locals.put("Answ", _answ);
 BA.debugLineNum = 456;BA.debugLine="If Answ = DialogResponse.POSITIVE Then";
Debug.ShouldStop(128);
if (_answ==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 BA.debugLineNum = 457;BA.debugLine="row = SelectedRow";
Debug.ShouldStop(256);
_row = _selectedrow;Debug.locals.put("row", _row);
 BA.debugLineNum = 458;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(512);
{
final double step381 = 1;
final double limit381 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step381 > 0 && _col <= limit381) || (step381 < 0 && _col >= limit381); _col += step381) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 459;BA.debugLine="GetView(row, col).Color = CellColor";
Debug.ShouldStop(1024);
_getview(_row,_col).setColor(_cellcolor);
 }
}Debug.locals.put("col", _col);
;
 BA.debugLineNum = 462;BA.debugLine="List_Delete(row)";
Debug.ShouldStop(8192);
_list_delete(_row);
 BA.debugLineNum = 463;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(16384);
_selectedrow = (int)(-1);
 BA.debugLineNum = 465;BA.debugLine="btnEdit.Visible = False";
Debug.ShouldStop(65536);
mostCurrent._btnedit.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 466;BA.debugLine="btnEditModif.Visible = False";
Debug.ShouldStop(131072);
mostCurrent._btneditmodif.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 467;BA.debugLine="btnDelete.Visible = False";
Debug.ShouldStop(262144);
mostCurrent._btndelete.setVisible(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 469;BA.debugLine="End Sub";
Debug.ShouldStop(1048576);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnedit_click() throws Exception{
		Debug.PushSubsStack("btnEdit_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 BA.debugLineNum = 499;BA.debugLine="Sub btnEdit_Click";
Debug.ShouldStop(262144);
 BA.debugLineNum = 500;BA.debugLine="Dim i As Int";
Debug.ShouldStop(524288);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 502;BA.debugLine="pnlEdit.Visible = True";
Debug.ShouldStop(2097152);
mostCurrent._pnledit.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 503;BA.debugLine="pnlEdit.BringToFront";
Debug.ShouldStop(4194304);
mostCurrent._pnledit.BringToFront();
 BA.debugLineNum = 504;BA.debugLine="Activity.Title = \"Editor\"";
Debug.ShouldStop(8388608);
mostCurrent._activity.setTitle((Object)("Editor"));
 BA.debugLineNum = 506;BA.debugLine="If NumberOfRows > 0 Then";
Debug.ShouldStop(33554432);
if (_numberofrows>0) { 
 BA.debugLineNum = 507;BA.debugLine="EditDispItem(SelectedRow)";
Debug.ShouldStop(67108864);
_editdispitem(_selectedrow);
 }else {
 BA.debugLineNum = 509;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(268435456);
{
final double step418 = 1;
final double limit418 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step418 > 0 && _i <= limit418) || (step418 < 0 && _i >= limit418); _i += step418) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 510;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(536870912);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 511;BA.debugLine="e = scvEdit.Panel.GetView(i * 2 + 1)";
Debug.ShouldStop(1073741824);
_e.setObject((android.widget.EditText)(mostCurrent._scvedit.getPanel().GetView((int)(_i*2+1)).getObject()));
 BA.debugLineNum = 512;BA.debugLine="e.Text = \"\"";
Debug.ShouldStop(-2147483648);
_e.setText((Object)(""));
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 515;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneditadd_click() throws Exception{
		Debug.PushSubsStack("btnEditAdd_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String[] _row = null;
int _i = 0;
int _hh = 0;
String _txt = "";
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 BA.debugLineNum = 561;BA.debugLine="Sub btnEditAdd_Click";
Debug.ShouldStop(65536);
 BA.debugLineNum = 562;BA.debugLine="Dim row(NumberOfColumns) As String";
Debug.ShouldStop(131072);
_row = new String[_numberofcolumns];
java.util.Arrays.fill(_row,"");Debug.locals.put("row", _row);
 BA.debugLineNum = 563;BA.debugLine="Dim i, hh As Int";
Debug.ShouldStop(262144);
_i = 0;Debug.locals.put("i", _i);
_hh = 0;Debug.locals.put("hh", _hh);
 BA.debugLineNum = 564;BA.debugLine="Dim txt As String";
Debug.ShouldStop(524288);
_txt = "";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 566;BA.debugLine="txt = \"SELECT max(\" & ColumnName(0) & \") FROM \" & DBTableName";
Debug.ShouldStop(2097152);
_txt = "SELECT max("+_columnname[(int)(0)]+") FROM "+_dbtablename;Debug.locals.put("txt", _txt);
 BA.debugLineNum = 567;BA.debugLine="row(0) = SQL1.ExecQuerySingleResult(txt) + 1";
Debug.ShouldStop(4194304);
_row[(int)(0)] = BA.NumberToString((double)(Double.parseDouble(_sql1.ExecQuerySingleResult(_txt)))+1);Debug.locals.put("row", _row);
 BA.debugLineNum = 569;BA.debugLine="txt = \"INSERT INTO \"&DBTableName&\" VALUES (NULL\"";
Debug.ShouldStop(16777216);
_txt = "INSERT INTO "+_dbtablename+" VALUES (NULL";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 570;BA.debugLine="For i = 1 To NumberOfColumns - 1";
Debug.ShouldStop(33554432);
{
final double step468 = 1;
final double limit468 = (int)(_numberofcolumns-1);
for (_i = (int)(1); (step468 > 0 && _i <= limit468) || (step468 < 0 && _i >= limit468); _i += step468) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 571;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(67108864);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 572;BA.debugLine="e = scvEdit.Panel.GetView(i * 2 + 1)";
Debug.ShouldStop(134217728);
_e.setObject((android.widget.EditText)(mostCurrent._scvedit.getPanel().GetView((int)(_i*2+1)).getObject()));
 BA.debugLineNum = 573;BA.debugLine="row(e.Tag) = e.Text";
Debug.ShouldStop(268435456);
_row[(int)(BA.ObjectToNumber(_e.getTag()))] = _e.getText();Debug.locals.put("row", _row);
 BA.debugLineNum = 574;BA.debugLine="txt = txt&\" , '\"&e.Text&\"'\"";
Debug.ShouldStop(536870912);
_txt = _txt+" , '"+_e.getText()+"'";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 575;BA.debugLine="If e.Text = \"\" Then";
Debug.ShouldStop(1073741824);
if ((_e.getText()).equals("")) { 
 BA.debugLineNum = 576;BA.debugLine="hh = hh + 1";
Debug.ShouldStop(-2147483648);
_hh = (int)(_hh+1);Debug.locals.put("hh", _hh);
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 579;BA.debugLine="txt = txt & \")\"";
Debug.ShouldStop(4);
_txt = _txt+")";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 581;BA.debugLine="If hh > 0 Then";
Debug.ShouldStop(16);
if (_hh>0) { 
 BA.debugLineNum = 582;BA.debugLine="Msgbox(\"There are \"&hh&\" data missing \",\"Attention\")";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.Msgbox("There are "+BA.NumberToString(_hh)+" data missing ","Attention",mostCurrent.activityBA);
 BA.debugLineNum = 583;BA.debugLine="Return";
Debug.ShouldStop(64);
if (true) return "";
 };
 BA.debugLineNum = 586;BA.debugLine="AddRow(row)";
Debug.ShouldStop(512);
_addrow(_row);
 BA.debugLineNum = 587;BA.debugLine="If NumberOfRows > 0 Then";
Debug.ShouldStop(1024);
if (_numberofrows>0) { 
 BA.debugLineNum = 588;BA.debugLine="btnEditModif.Visible = True";
Debug.ShouldStop(2048);
mostCurrent._btneditmodif.setVisible(anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 591;BA.debugLine="SQL1.ExecNonQuery(txt)";
Debug.ShouldStop(16384);
_sql1.ExecNonQuery(_txt);
 BA.debugLineNum = 593;BA.debugLine="hh = (NumberOfRows - NumberOfVisibleRows + 1) * RowHeight";
Debug.ShouldStop(65536);
_hh = (int)((_numberofrows-_numberofvisiblerows+1)*_rowheight);Debug.locals.put("hh", _hh);
 BA.debugLineNum = 594;BA.debugLine="If hh < 0 Then";
Debug.ShouldStop(131072);
if (_hh<0) { 
 BA.debugLineNum = 595;BA.debugLine="hh = 0";
Debug.ShouldStop(262144);
_hh = (int)(0);Debug.locals.put("hh", _hh);
 };
 BA.debugLineNum = 597;BA.debugLine="scvPersons.ScrollPosition = hh";
Debug.ShouldStop(1048576);
mostCurrent._scvpersons.setScrollPosition(_hh);
 BA.debugLineNum = 598;BA.debugLine="DoEvents";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.DoEvents();
 BA.debugLineNum = 599;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneditback_click() throws Exception{
		Debug.PushSubsStack("btnEditBack_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 532;BA.debugLine="Sub btnEditBack_Click";
Debug.ShouldStop(524288);
 BA.debugLineNum = 533;BA.debugLine="pnlEdit.Visible = False";
Debug.ShouldStop(1048576);
mostCurrent._pnledit.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 534;BA.debugLine="Activity.Title = \"Database\"";
Debug.ShouldStop(2097152);
mostCurrent._activity.setTitle((Object)("Database"));
 BA.debugLineNum = 535;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneditmodif_click() throws Exception{
		Debug.PushSubsStack("btnEditModif_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String[] _row = null;
int _i = 0;
String _txt = "";
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 BA.debugLineNum = 537;BA.debugLine="Sub btnEditModif_Click";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 538;BA.debugLine="Dim row(NumberOfColumns) As String";
Debug.ShouldStop(33554432);
_row = new String[_numberofcolumns];
java.util.Arrays.fill(_row,"");Debug.locals.put("row", _row);
 BA.debugLineNum = 539;BA.debugLine="Dim i As Int";
Debug.ShouldStop(67108864);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 540;BA.debugLine="Dim txt As String";
Debug.ShouldStop(134217728);
_txt = "";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 542;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(536870912);
{
final double step446 = 1;
final double limit446 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step446 > 0 && _i <= limit446) || (step446 < 0 && _i >= limit446); _i += step446) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 543;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(1073741824);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 544;BA.debugLine="e = scvEdit.Panel.GetView(i * 2 + 1)";
Debug.ShouldStop(-2147483648);
_e.setObject((android.widget.EditText)(mostCurrent._scvedit.getPanel().GetView((int)(_i*2+1)).getObject()));
 BA.debugLineNum = 545;BA.debugLine="row(e.Tag) = e.Text";
Debug.ShouldStop(1);
_row[(int)(BA.ObjectToNumber(_e.getTag()))] = _e.getText();Debug.locals.put("row", _row);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 548;BA.debugLine="txt=\"UPDATE \"&DBTableName&\" Set \"&ColumnName(0)&\" = '\" & row(0)";
Debug.ShouldStop(8);
_txt = "UPDATE "+_dbtablename+" Set "+_columnname[(int)(0)]+" = '"+_row[(int)(0)];Debug.locals.put("txt", _txt);
 BA.debugLineNum = 549;BA.debugLine="For i = 1 To NumberOfColumns - 1";
Debug.ShouldStop(16);
{
final double step452 = 1;
final double limit452 = (int)(_numberofcolumns-1);
for (_i = (int)(1); (step452 > 0 && _i <= limit452) || (step452 < 0 && _i >= limit452); _i += step452) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 550;BA.debugLine="txt = txt & \"', \"&ColumnName(i) & \" = '\" & row(i)";
Debug.ShouldStop(32);
_txt = _txt+"', "+_columnname[_i]+" = '"+_row[_i];Debug.locals.put("txt", _txt);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 552;BA.debugLine="txt=txt&\"' WHERE \"&ColumnName(0)&\" = '\"&GetCell(SelectedRow,0)& \"'\"";
Debug.ShouldStop(128);
_txt = _txt+"' WHERE "+_columnname[(int)(0)]+" = '"+_getcell(_selectedrow,(int)(0))+"'";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 553;BA.debugLine="SQL1.ExecNonQuery(txt)";
Debug.ShouldStop(256);
_sql1.ExecNonQuery(_txt);
 BA.debugLineNum = 555;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(1024);
{
final double step457 = 1;
final double limit457 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step457 > 0 && _i <= limit457) || (step457 < 0 && _i >= limit457); _i += step457) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 556;BA.debugLine="SetCell(SelectedRow,i,row(i))";
Debug.ShouldStop(2048);
_setcell(_selectedrow,_i,_row[_i]);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 559;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneditmove_click() throws Exception{
		Debug.PushSubsStack("btnEditMove_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
main._rowcol _rc = null;
int _i = 0;
int _j = 0;
anywheresoftware.b4a.objects.ButtonWrapper _send = null;
 BA.debugLineNum = 662;BA.debugLine="Sub btnEditMove_Click";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 663;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(4194304);
_rc = new main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 664;BA.debugLine="Dim i, j As Int";
Debug.ShouldStop(8388608);
_i = 0;Debug.locals.put("i", _i);
_j = 0;Debug.locals.put("j", _j);
 BA.debugLineNum = 665;BA.debugLine="Dim Send As Button";
Debug.ShouldStop(16777216);
_send = new anywheresoftware.b4a.objects.ButtonWrapper();Debug.locals.put("Send", _send);
 BA.debugLineNum = 667;BA.debugLine="If btnEditMove.IsInitialized Then";
Debug.ShouldStop(67108864);
if (mostCurrent._btneditmove.IsInitialized()) { 
 BA.debugLineNum = 668;BA.debugLine="btnEditMove.Visible = True	' sets the previous button visible to true";
Debug.ShouldStop(134217728);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 671;BA.debugLine="btnEditMove = Sender					' remembers the current used button";
Debug.ShouldStop(1073741824);
mostCurrent._btneditmove.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 673;BA.debugLine="i = SelectedRow";
Debug.ShouldStop(1);
_i = _selectedrow;Debug.locals.put("i", _i);
 BA.debugLineNum = 675;BA.debugLine="Select btnEditMove.Tag";
Debug.ShouldStop(4);
switch (BA.switchObjectToInt(mostCurrent._btneditmove.getTag(),(Object)("EditPrev"),(Object)("EditNext"))) {
case 0:
 BA.debugLineNum = 677;BA.debugLine="i = i - 1";
Debug.ShouldStop(16);
_i = (int)(_i-1);Debug.locals.put("i", _i);
 BA.debugLineNum = 678;BA.debugLine="If i = 0 Then";
Debug.ShouldStop(32);
if (_i==0) { 
 BA.debugLineNum = 679;BA.debugLine="btnEditMove.Visible = False";
Debug.ShouldStop(64);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.False);
 };
 break;
case 1:
 BA.debugLineNum = 682;BA.debugLine="i = i + 1";
Debug.ShouldStop(512);
_i = (int)(_i+1);Debug.locals.put("i", _i);
 BA.debugLineNum = 683;BA.debugLine="If i = NumberOfRows - 1 Then";
Debug.ShouldStop(1024);
if (_i==_numberofrows-1) { 
 BA.debugLineNum = 684;BA.debugLine="btnEditMove.Visible = False";
Debug.ShouldStop(2048);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.False);
 };
 break;
}
;
 BA.debugLineNum = 687;BA.debugLine="rc.Row = i";
Debug.ShouldStop(16384);
_rc.Row = _i;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 689;BA.debugLine="SelectRow(rc)";
Debug.ShouldStop(65536);
_selectrow(_rc);
 BA.debugLineNum = 690;BA.debugLine="j = (i - NumberOfVisibleRows / 2) * RowHeight";
Debug.ShouldStop(131072);
_j = (int)((_i-_numberofvisiblerows/(double)2)*_rowheight);Debug.locals.put("j", _j);
 BA.debugLineNum = 691;BA.debugLine="If j < 0 Then";
Debug.ShouldStop(262144);
if (_j<0) { 
 BA.debugLineNum = 692;BA.debugLine="j = 0";
Debug.ShouldStop(524288);
_j = (int)(0);Debug.locals.put("j", _j);
 };
 BA.debugLineNum = 694;BA.debugLine="scvPersons.ScrollPosition = j";
Debug.ShouldStop(2097152);
mostCurrent._scvpersons.setScrollPosition(_j);
 BA.debugLineNum = 696;BA.debugLine="EditDispItem(SelectedRow)";
Debug.ShouldStop(8388608);
_editdispitem(_selectedrow);
 BA.debugLineNum = 697;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneditmove_longclick() throws Exception{
		Debug.PushSubsStack("btnEditMove_LongClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
main._rowcol _rc = null;
int _i = 0;
int _j = 0;
 BA.debugLineNum = 699;BA.debugLine="Sub btnEditMove_LongClick";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 700;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(134217728);
_rc = new main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 701;BA.debugLine="Dim i, j As Int";
Debug.ShouldStop(268435456);
_i = 0;Debug.locals.put("i", _i);
_j = 0;Debug.locals.put("j", _j);
 BA.debugLineNum = 703;BA.debugLine="If btnEditMove.IsInitialized Then";
Debug.ShouldStop(1073741824);
if (mostCurrent._btneditmove.IsInitialized()) { 
 BA.debugLineNum = 704;BA.debugLine="btnEditMove.Visible = True	' sets the previous button visible to true";
Debug.ShouldStop(-2147483648);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 707;BA.debugLine="btnEditMove = Sender					' remembers the current used button";
Debug.ShouldStop(4);
mostCurrent._btneditmove.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 709;BA.debugLine="Select btnEditMove.Tag";
Debug.ShouldStop(16);
switch (BA.switchObjectToInt(mostCurrent._btneditmove.getTag(),(Object)("EditPrev"),(Object)("EditNext"))) {
case 0:
 BA.debugLineNum = 711;BA.debugLine="btnEditMove.Visible = False";
Debug.ShouldStop(64);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 712;BA.debugLine="i = 0";
Debug.ShouldStop(128);
_i = (int)(0);Debug.locals.put("i", _i);
 break;
case 1:
 BA.debugLineNum = 714;BA.debugLine="btnEditMove.Visible = False";
Debug.ShouldStop(512);
mostCurrent._btneditmove.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 715;BA.debugLine="i = NumberOfRows - 1";
Debug.ShouldStop(1024);
_i = (int)(_numberofrows-1);Debug.locals.put("i", _i);
 break;
}
;
 BA.debugLineNum = 717;BA.debugLine="rc.Col = 0";
Debug.ShouldStop(4096);
_rc.Col = (int)(0);Debug.locals.put("rc", _rc);
 BA.debugLineNum = 718;BA.debugLine="rc.Row = i";
Debug.ShouldStop(8192);
_rc.Row = _i;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 720;BA.debugLine="SelectRow(rc)";
Debug.ShouldStop(32768);
_selectrow(_rc);
 BA.debugLineNum = 721;BA.debugLine="j = (i - NumberOfVisibleRows / 2) * RowHeight";
Debug.ShouldStop(65536);
_j = (int)((_i-_numberofvisiblerows/(double)2)*_rowheight);Debug.locals.put("j", _j);
 BA.debugLineNum = 722;BA.debugLine="If j < 0 Then";
Debug.ShouldStop(131072);
if (_j<0) { 
 BA.debugLineNum = 723;BA.debugLine="j = 0";
Debug.ShouldStop(262144);
_j = (int)(0);Debug.locals.put("j", _j);
 };
 BA.debugLineNum = 725;BA.debugLine="scvPersons.ScrollPosition = j";
Debug.ShouldStop(1048576);
mostCurrent._scvpersons.setScrollPosition(_j);
 BA.debugLineNum = 727;BA.debugLine="EditDispItem(SelectedRow)";
Debug.ShouldStop(4194304);
_editdispitem(_selectedrow);
 BA.debugLineNum = 728;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfilter_click() throws Exception{
		Debug.PushSubsStack("btnFilter_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 601;BA.debugLine="Sub btnFilter_Click";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 602;BA.debugLine="Filter = Not(Filter)";
Debug.ShouldStop(33554432);
_filter = anywheresoftware.b4a.keywords.Common.Not(_filter);
 BA.debugLineNum = 603;BA.debugLine="If Filter = True Then";
Debug.ShouldStop(67108864);
if (_filter==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 604;BA.debugLine="btnFilter.Text = \"Un Filter\"";
Debug.ShouldStop(134217728);
mostCurrent._btnfilter.setText((Object)("Un Filter"));
 }else {
 BA.debugLineNum = 606;BA.debugLine="btnFilter.Text = \"Filter\"";
Debug.ShouldStop(536870912);
mostCurrent._btnfilter.setText((Object)("Filter"));
 };
 BA.debugLineNum = 608;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(-2147483648);
_selectedrow = (int)(-1);
 BA.debugLineNum = 609;BA.debugLine="btnEdit.Visible = False";
Debug.ShouldStop(1);
mostCurrent._btnedit.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 610;BA.debugLine="btnDelete.Visible = False";
Debug.ShouldStop(2);
mostCurrent._btndelete.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 611;BA.debugLine="SQLTableRead";
Debug.ShouldStop(4);
_sqltableread();
 BA.debugLineNum = 612;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfilter_longclick() throws Exception{
		Debug.PushSubsStack("btnFilter_LongClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 614;BA.debugLine="Sub btnFilter_LongClick";
Debug.ShouldStop(32);
 BA.debugLineNum = 615;BA.debugLine="pnlFilter.Visible = True";
Debug.ShouldStop(64);
mostCurrent._pnlfilter.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 616;BA.debugLine="pnlFilter.BringToFront";
Debug.ShouldStop(128);
mostCurrent._pnlfilter.BringToFront();
 BA.debugLineNum = 617;BA.debugLine="Activity.Title = \"Filter\"";
Debug.ShouldStop(256);
mostCurrent._activity.setTitle((Object)("Filter"));
 BA.debugLineNum = 618;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfilterand_click() throws Exception{
		Debug.PushSubsStack("btnFilterAND_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 632;BA.debugLine="Sub btnFilterAND_Click";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 633;BA.debugLine="btnFilterOR.TextColor = Colors.Red";
Debug.ShouldStop(16777216);
mostCurrent._btnfilteror.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 BA.debugLineNum = 634;BA.debugLine="FilterType = \"AND\"";
Debug.ShouldStop(33554432);
_filtertype = "AND";
 BA.debugLineNum = 635;BA.debugLine="btnFilterAND.TextColor = Colors.RGB(0,255,0)";
Debug.ShouldStop(67108864);
mostCurrent._btnfilterand.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0),(int)(255),(int)(0)));
 BA.debugLineNum = 636;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfilterback_click() throws Exception{
		Debug.PushSubsStack("btnFilterBack_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 627;BA.debugLine="Sub btnFilterBack_Click";
Debug.ShouldStop(262144);
 BA.debugLineNum = 628;BA.debugLine="pnlFilter.Visible = False";
Debug.ShouldStop(524288);
mostCurrent._pnlfilter.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 629;BA.debugLine="Activity.Title = \"Database\"";
Debug.ShouldStop(1048576);
mostCurrent._activity.setTitle((Object)("Database"));
 BA.debugLineNum = 630;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfiltergo_click() throws Exception{
		Debug.PushSubsStack("btnFilterGo_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 620;BA.debugLine="Sub btnFilterGo_Click";
Debug.ShouldStop(2048);
 BA.debugLineNum = 621;BA.debugLine="Filter = True";
Debug.ShouldStop(4096);
_filter = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 622;BA.debugLine="btnFilterBack_Click";
Debug.ShouldStop(8192);
_btnfilterback_click();
 BA.debugLineNum = 623;BA.debugLine="btnFilter.Text = \"Un Filter\"";
Debug.ShouldStop(16384);
mostCurrent._btnfilter.setText((Object)("Un Filter"));
 BA.debugLineNum = 624;BA.debugLine="SQLTableRead";
Debug.ShouldStop(32768);
_sqltableread();
 BA.debugLineNum = 625;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfilteror_click() throws Exception{
		Debug.PushSubsStack("btnFilterOR_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 638;BA.debugLine="Sub btnFilterOR_Click";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 639;BA.debugLine="btnFilterAND.TextColor = Colors.Red";
Debug.ShouldStop(1073741824);
mostCurrent._btnfilterand.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 BA.debugLineNum = 640;BA.debugLine="FilterType = \"OR\"";
Debug.ShouldStop(-2147483648);
_filtertype = "OR";
 BA.debugLineNum = 641;BA.debugLine="btnFilterOR.TextColor = Colors.RGB(0,255,0)";
Debug.ShouldStop(1);
mostCurrent._btnfilteror.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0),(int)(255),(int)(0)));
 BA.debugLineNum = 642;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cell_click() throws Exception{
		Debug.PushSubsStack("Cell_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
main._rowcol _rc = null;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
 BA.debugLineNum = 213;BA.debugLine="Sub Cell_Click";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 214;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(2097152);
_rc = new main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 215;BA.debugLine="Dim l As Label";
Debug.ShouldStop(4194304);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 217;BA.debugLine="l = Sender";
Debug.ShouldStop(16777216);
_l.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 218;BA.debugLine="rc = l.Tag";
Debug.ShouldStop(33554432);
_rc = (main._rowcol)(_l.getTag());Debug.locals.put("rc", _rc);
 BA.debugLineNum = 219;BA.debugLine="SelectRow(rc)";
Debug.ShouldStop(67108864);
_selectrow(_rc);
 BA.debugLineNum = 220;BA.debugLine="Activity.Title = \"Cell: (\" & rc.Row & \", \" & rc.Col & \")  \" & GetCell(rc.Row, rc.Col)";
Debug.ShouldStop(134217728);
mostCurrent._activity.setTitle((Object)("Cell: ("+BA.NumberToString(_rc.Row)+", "+BA.NumberToString(_rc.Col)+")  "+_getcell(_rc.Row,_rc.Col)));
 BA.debugLineNum = 221;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _clearall() throws Exception{
		Debug.PushSubsStack("ClearAll (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
 BA.debugLineNum = 339;BA.debugLine="Sub ClearAll";
Debug.ShouldStop(262144);
 BA.debugLineNum = 341;BA.debugLine="For i = scvPersons.Panel.NumberOfViews -1 To 0 Step -1";
Debug.ShouldStop(1048576);
{
final double step283 = -1;
final double limit283 = (int)(0);
for (_i = (int)(mostCurrent._scvpersons.getPanel().getNumberOfViews()-1); (step283 > 0 && _i <= limit283) || (step283 < 0 && _i >= limit283); _i += step283) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 342;BA.debugLine="scvPersons.Panel.RemoveViewAt(i)";
Debug.ShouldStop(2097152);
mostCurrent._scvpersons.getPanel().RemoveViewAt(_i);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 344;BA.debugLine="scvPersons.Panel.Height = 0";
Debug.ShouldStop(8388608);
mostCurrent._scvpersons.getPanel().setHeight((int)(0));
 BA.debugLineNum = 345;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(16777216);
_selectedrow = (int)(-1);
 BA.debugLineNum = 346;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _editdispitem(int _row) throws Exception{
		Debug.PushSubsStack("EditDispItem (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
int _i = 0;
String _txt = "";
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
Debug.locals.put("Row", _row);
 BA.debugLineNum = 517;BA.debugLine="Sub EditDispItem(Row As Int)";
Debug.ShouldStop(16);
 BA.debugLineNum = 518;BA.debugLine="Dim Cursor1 As Cursor";
Debug.ShouldStop(32);
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();Debug.locals.put("Cursor1", _cursor1);
 BA.debugLineNum = 519;BA.debugLine="Dim i As Int";
Debug.ShouldStop(64);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 520;BA.debugLine="Dim txt As String";
Debug.ShouldStop(128);
_txt = "";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 522;BA.debugLine="txt = \"SELECT * FROM \" & DBTableName & \" WHERE \" & ColumnName(0) & \" = \" & GetCell(Row,0)";
Debug.ShouldStop(512);
_txt = "SELECT * FROM "+_dbtablename+" WHERE "+_columnname[(int)(0)]+" = "+_getcell(_row,(int)(0));Debug.locals.put("txt", _txt);
 BA.debugLineNum = 523;BA.debugLine="Cursor1 = SQL1.ExecQuery(txt)";
Debug.ShouldStop(1024);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery(_txt)));
 BA.debugLineNum = 524;BA.debugLine="Cursor1.Position = 0";
Debug.ShouldStop(2048);
_cursor1.setPosition((int)(0));
 BA.debugLineNum = 525;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(4096);
{
final double step432 = 1;
final double limit432 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step432 > 0 && _i <= limit432) || (step432 < 0 && _i >= limit432); _i += step432) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 526;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(8192);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 527;BA.debugLine="e = scvEdit.Panel.GetView(i * 2 + 1)";
Debug.ShouldStop(16384);
_e.setObject((android.widget.EditText)(mostCurrent._scvedit.getPanel().GetView((int)(_i*2+1)).getObject()));
 BA.debugLineNum = 528;BA.debugLine="e.Text = Cursor1.GetString(ColumnName(e.Tag))";
Debug.ShouldStop(32768);
_e.setText((Object)(_cursor1.GetString(_columnname[(int)(BA.ObjectToNumber(_e.getTag()))])));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 530;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _edtedit_focuschanged(boolean _hasfocus) throws Exception{
		Debug.PushSubsStack("edtEdit_FocusChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.EditTextWrapper _send = null;
Debug.locals.put("HasFocus", _hasfocus);
 BA.debugLineNum = 644;BA.debugLine="Sub edtEdit_FocusChanged(HasFocus As Boolean)";
Debug.ShouldStop(8);
 BA.debugLineNum = 645;BA.debugLine="Dim Send As EditText";
Debug.ShouldStop(16);
_send = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("Send", _send);
 BA.debugLineNum = 647;BA.debugLine="If HasFocus = True Then";
Debug.ShouldStop(64);
if (_hasfocus==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 648;BA.debugLine="Send = Sender";
Debug.ShouldStop(128);
_send.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 649;BA.debugLine="scvEdit.ScrollPosition = Send.Top - 40dip";
Debug.ShouldStop(256);
mostCurrent._scvedit.setScrollPosition((int)(_send.getTop()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(40))));
 };
 BA.debugLineNum = 651;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _edtfilter_focuschanged(boolean _hasfocus) throws Exception{
		Debug.PushSubsStack("edtFilter_FocusChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.EditTextWrapper _send = null;
Debug.locals.put("HasFocus", _hasfocus);
 BA.debugLineNum = 653;BA.debugLine="Sub edtFilter_FocusChanged(HasFocus As Boolean)";
Debug.ShouldStop(4096);
 BA.debugLineNum = 654;BA.debugLine="Dim Send As EditText";
Debug.ShouldStop(8192);
_send = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("Send", _send);
 BA.debugLineNum = 656;BA.debugLine="If HasFocus = True Then";
Debug.ShouldStop(32768);
if (_hasfocus==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 657;BA.debugLine="Send = Sender";
Debug.ShouldStop(65536);
_send.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 658;BA.debugLine="scvFilter.ScrollPosition = Send.Top - 40dip";
Debug.ShouldStop(131072);
mostCurrent._scvfilter.setScrollPosition((int)(_send.getTop()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(40))));
 };
 BA.debugLineNum = 660;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _getcell(int _row,int _col) throws Exception{
		Debug.PushSubsStack("GetCell (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 334;BA.debugLine="Sub GetCell(Row As Int, Col As Int) As String";
Debug.ShouldStop(8192);
 BA.debugLineNum = 336;BA.debugLine="Return GetView(Row, Col).Text";
Debug.ShouldStop(32768);
if (true) return _getview(_row,_col).getText();
 BA.debugLineNum = 337;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static anywheresoftware.b4a.objects.LabelWrapper  _getview(int _row,int _col) throws Exception{
		Debug.PushSubsStack("GetView (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.LabelWrapper _l = null;
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 266;BA.debugLine="Sub GetView(Row As Int, Col As Int) As Label";
Debug.ShouldStop(512);
 BA.debugLineNum = 268;BA.debugLine="Dim l As Label";
Debug.ShouldStop(2048);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 270;BA.debugLine="l = scvPersons.Panel.GetView(Row * NumberOfColumns + Col)";
Debug.ShouldStop(8192);
_l.setObject((android.widget.TextView)(mostCurrent._scvpersons.getPanel().GetView((int)(_row*_numberofcolumns+_col)).getObject()));
 BA.debugLineNum = 271;BA.debugLine="Return l";
Debug.ShouldStop(16384);
if (true) return _l;
 BA.debugLineNum = 272;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return null;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 9955, new int[] {23}, "b3795d99-383b-4582-a870-94e183d1cfef");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 61;BA.debugLine="Dim scvPersons, scvEdit, scvFilter As ScrollView";
mostCurrent._scvpersons = new anywheresoftware.b4a.objects.ScrollViewWrapper();
mostCurrent._scvedit = new anywheresoftware.b4a.objects.ScrollViewWrapper();
mostCurrent._scvfilter = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 62;BA.debugLine="Dim pnlToolBox, pnlEdit, pnlEditTools, pnlFilter, pnlFilterTools As Panel";
mostCurrent._pnltoolbox = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnledit = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnledittools = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnlfilter = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnlfiltertools = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 63;BA.debugLine="Dim btnEditAdd, btnDelete, btnEdit, btnEditModif, btnEditMove, btnLoad As Button";
mostCurrent._btneditadd = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btndelete = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnedit = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btneditmodif = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btneditmove = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnload = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 64;BA.debugLine="Dim btnFilter, btnFilterGo, btnFilterAND, btnFilterOR, btnFilterType As Button";
mostCurrent._btnfilter = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnfiltergo = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnfilterand = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnfilteror = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnfiltertype = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 65;BA.debugLine="Dim pnlHeader As Panel";
mostCurrent._pnlheader = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 66;BA.debugLine="Dim skbScroll As SeekBar";
mostCurrent._skbscroll = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 67;BA.debugLine="Dim pnlScroll As Panel";
mostCurrent._pnlscroll = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 68;BA.debugLine="Dim Timer1 As Timer";
mostCurrent._timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 70;BA.debugLine="Dim LHeight As Float";
_lheight = 0f;
 //BA.debugLineNum = 71;BA.debugLine="Dim EHeight As Float";
_eheight = 0f;
 //BA.debugLineNum = 72;BA.debugLine="Dim THeight As Float";
_theight = 0f;
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _header_click() throws Exception{
		Debug.PushSubsStack("Header_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.LabelWrapper _l = null;
int _col = 0;
 BA.debugLineNum = 223;BA.debugLine="Sub Header_Click";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 224;BA.debugLine="Dim l As Label";
Debug.ShouldStop(-2147483648);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 225;BA.debugLine="Dim col As Int";
Debug.ShouldStop(1);
_col = 0;Debug.locals.put("col", _col);
 BA.debugLineNum = 227;BA.debugLine="l = Sender";
Debug.ShouldStop(4);
_l.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 228;BA.debugLine="col = l.Tag";
Debug.ShouldStop(8);
_col = (int)(BA.ObjectToNumber(_l.getTag()));Debug.locals.put("col", _col);
 BA.debugLineNum = 229;BA.debugLine="Activity.Title = \"Header clicked: \" & col";
Debug.ShouldStop(16);
mostCurrent._activity.setTitle((Object)("Header clicked: "+BA.NumberToString(_col)));
 BA.debugLineNum = 231;BA.debugLine="ColumnToSort = col";
Debug.ShouldStop(64);
_columntosort = BA.NumberToString(_col);
 BA.debugLineNum = 232;BA.debugLine="SQLTableRead";
Debug.ShouldStop(128);
_sqltableread();
 BA.debugLineNum = 233;BA.debugLine="Log(scvPersons.Panel.NumberOfViews)";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(mostCurrent._scvpersons.getPanel().getNumberOfViews()));
 BA.debugLineNum = 234;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _list_delete(int _row) throws Exception{
		Debug.PushSubsStack("List_Delete (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
int _j = 0;
String _txt = "";
Debug.locals.put("Row", _row);
 BA.debugLineNum = 471;BA.debugLine="Sub List_Delete(Row As Int)";
Debug.ShouldStop(4194304);
 BA.debugLineNum = 473;BA.debugLine="Dim i, j As Int";
Debug.ShouldStop(16777216);
_i = 0;Debug.locals.put("i", _i);
_j = 0;Debug.locals.put("j", _j);
 BA.debugLineNum = 474;BA.debugLine="Dim txt As String";
Debug.ShouldStop(33554432);
_txt = "";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 476;BA.debugLine="SQL1.ExecNonQuery(\"DELETE FROM \"&DBTableName&\" WHERE \" & _ 			ColumnName(0) & \" = '\" & GetView(Row,0).Text & \"'\")";
Debug.ShouldStop(134217728);
_sql1.ExecNonQuery("DELETE FROM "+_dbtablename+" WHERE "+_columnname[(int)(0)]+" = '"+_getview(_row,(int)(0)).getText()+"'");
 BA.debugLineNum = 480;BA.debugLine="For i = Row To NumberOfRows - 2";
Debug.ShouldStop(-2147483648);
{
final double step395 = 1;
final double limit395 = (int)(_numberofrows-2);
for (_i = _row; (step395 > 0 && _i <= limit395) || (step395 < 0 && _i >= limit395); _i += step395) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 481;BA.debugLine="For j = 0 To NumberOfColumns - 1";
Debug.ShouldStop(1);
{
final double step396 = 1;
final double limit396 = (int)(_numberofcolumns-1);
for (_j = (int)(0); (step396 > 0 && _j <= limit396) || (step396 < 0 && _j >= limit396); _j += step396) {
Debug.locals.put("j", _j);
 BA.debugLineNum = 482;BA.debugLine="GetView(i,j).Text = GetView(i + 1,j).Text";
Debug.ShouldStop(2);
_getview(_i,_j).setText((Object)(_getview((int)(_i+1),_j).getText()));
 }
}Debug.locals.put("j", _j);
;
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 487;BA.debugLine="For j = NumberOfColumns - 1 To 0 Step -1";
Debug.ShouldStop(64);
{
final double step400 = -1;
final double limit400 = (int)(0);
for (_j = (int)(_numberofcolumns-1); (step400 > 0 && _j <= limit400) || (step400 < 0 && _j >= limit400); _j += step400) {
Debug.locals.put("j", _j);
 BA.debugLineNum = 488;BA.debugLine="scvPersons.Panel.RemoveViewAt((NumberOfRows - 1) * NumberOfColumns + j)";
Debug.ShouldStop(128);
mostCurrent._scvpersons.getPanel().RemoveViewAt((int)((_numberofrows-1)*_numberofcolumns+_j));
 }
}Debug.locals.put("j", _j);
;
 BA.debugLineNum = 491;BA.debugLine="NumberOfRows = NumberOfRows - 1   ' updates the number of rowa";
Debug.ShouldStop(1024);
_numberofrows = (int)(_numberofrows-1);
 BA.debugLineNum = 492;BA.debugLine="If NumberOfRows > 0 Then					' updates the ScrollView Panel height";
Debug.ShouldStop(2048);
if (_numberofrows>0) { 
 BA.debugLineNum = 493;BA.debugLine="scvPersons.Panel.Height = NumberOfRows * RowHeight";
Debug.ShouldStop(4096);
mostCurrent._scvpersons.getPanel().setHeight((int)(_numberofrows*_rowheight));
 }else {
 BA.debugLineNum = 495;BA.debugLine="scvPersons.Panel.Height = RowHeight";
Debug.ShouldStop(16384);
mostCurrent._scvpersons.getPanel().setHeight(_rowheight);
 };
 BA.debugLineNum = 497;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _pnlscroll_touch(int _action,float _x,float _y) throws Exception{
		Debug.PushSubsStack("pnlScroll_Touch (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
float _left = 0f;
Debug.locals.put("Action", _action);
Debug.locals.put("X", _x);
Debug.locals.put("Y", _y);
 BA.debugLineNum = 354;BA.debugLine="Sub pnlScroll_Touch (Action As Int, X As Float, Y As Float)";
Debug.ShouldStop(2);
 BA.debugLineNum = 355;BA.debugLine="Dim Left As Float";
Debug.ShouldStop(4);
_left = 0f;Debug.locals.put("Left", _left);
 BA.debugLineNum = 357;BA.debugLine="Select Action";
Debug.ShouldStop(16);
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 BA.debugLineNum = 359;BA.debugLine="MoveLeft0 = -scvPersons.Left";
Debug.ShouldStop(64);
_moveleft0 = (float)(-mostCurrent._scvpersons.getLeft());
 BA.debugLineNum = 360;BA.debugLine="MoveX0 = X";
Debug.ShouldStop(128);
_movex0 = _x;
 BA.debugLineNum = 361;BA.debugLine="MoveX1 = X";
Debug.ShouldStop(256);
_movex1 = _x;
 BA.debugLineNum = 362;BA.debugLine="Time0 = DateTime.Now";
Debug.ShouldStop(512);
_time0 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 break;
case 1:
 BA.debugLineNum = 364;BA.debugLine="Left = MoveLeft0 + (MoveX0 - X)";
Debug.ShouldStop(2048);
_left = (float)(_moveleft0+(_movex0-_x));Debug.locals.put("Left", _left);
 BA.debugLineNum = 365;BA.debugLine="Left = Max(Left, 0)";
Debug.ShouldStop(4096);
_left = (float)(anywheresoftware.b4a.keywords.Common.Max(_left,0));Debug.locals.put("Left", _left);
 BA.debugLineNum = 366;BA.debugLine="Left = Min(Left, TotalColumnWidth(NumberOfColumns) - Activity.Width)";
Debug.ShouldStop(8192);
_left = (float)(anywheresoftware.b4a.keywords.Common.Min(_left,_totalcolumnwidth[_numberofcolumns]-mostCurrent._activity.getWidth()));Debug.locals.put("Left", _left);
 BA.debugLineNum = 367;BA.debugLine="scvPersons.Left = -Left";
Debug.ShouldStop(16384);
mostCurrent._scvpersons.setLeft((int)(-_left));
 BA.debugLineNum = 368;BA.debugLine="pnlHeader.Left = -Left";
Debug.ShouldStop(32768);
mostCurrent._pnlheader.setLeft((int)(-_left));
 BA.debugLineNum = 369;BA.debugLine="DeltaX = X - MoveX1";
Debug.ShouldStop(65536);
_deltax = (float)(_x-_movex1);
 BA.debugLineNum = 370;BA.debugLine="MoveX1 = X";
Debug.ShouldStop(131072);
_movex1 = _x;
 break;
case 2:
 BA.debugLineNum = 372;BA.debugLine="Time0 = (DateTime.Now - Time0)";
Debug.ShouldStop(524288);
_time0 = (long)((anywheresoftware.b4a.keywords.Common.DateTime.getNow()-_time0));
 BA.debugLineNum = 373;BA.debugLine="DeltaScroll = (X - MoveX0) / Time0 * 80";
Debug.ShouldStop(1048576);
_deltascroll = (float)((_x-_movex0)/(double)_time0*80);
 BA.debugLineNum = 374;BA.debugLine="If Abs(DeltaScroll) > 5dip AND Abs(DeltaX) > 10dip Then";
Debug.ShouldStop(2097152);
if (anywheresoftware.b4a.keywords.Common.Abs(_deltascroll)>anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)) && anywheresoftware.b4a.keywords.Common.Abs(_deltax)>anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))) { 
 BA.debugLineNum = 375;BA.debugLine="Timer1.Enabled = True";
Debug.ShouldStop(4194304);
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 break;
}
;
 BA.debugLineNum = 378;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 2;BA.debugLine="Dim ProgName As String					: ProgName = \"SQLExample\"";
_progname = "";
 //BA.debugLineNum = 2;BA.debugLine="Dim ProgName As String					: ProgName = \"SQLExample\"";
_progname = "SQLExample";
 //BA.debugLineNum = 3;BA.debugLine="Dim ProgVersion As String				: ProgVersion = \" V 1.1\"";
_progversion = "";
 //BA.debugLineNum = 3;BA.debugLine="Dim ProgVersion As String				: ProgVersion = \" V 1.1\"";
_progversion = " V 1.1";
 //BA.debugLineNum = 5;BA.debugLine="Dim SQL1 As SQL";
_sql1 = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 7;BA.debugLine="Dim DBFileName As String				: DBFileName = \"persons.db\"";
_dbfilename = "";
 //BA.debugLineNum = 7;BA.debugLine="Dim DBFileName As String				: DBFileName = \"persons.db\"";
_dbfilename = "persons.db";
 //BA.debugLineNum = 9;BA.debugLine="Dim DBFileDir As String					: DBFileDir = File.DirRootExternal";
_dbfiledir = "";
 //BA.debugLineNum = 9;BA.debugLine="Dim DBFileDir As String					: DBFileDir = File.DirRootExternal";
_dbfiledir = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal();
 //BA.debugLineNum = 11;BA.debugLine="Dim DBTableName As String				: DBTableName = \"persons\"";
_dbtablename = "";
 //BA.debugLineNum = 11;BA.debugLine="Dim DBTableName As String				: DBTableName = \"persons\"";
_dbtablename = "persons";
 //BA.debugLineNum = 14;BA.debugLine="Dim NumberOfColumns As Int			: NumberOfColumns = 5";
_numberofcolumns = 0;
 //BA.debugLineNum = 14;BA.debugLine="Dim NumberOfColumns As Int			: NumberOfColumns = 5";
_numberofcolumns = (int)(5);
 //BA.debugLineNum = 15;BA.debugLine="Dim NumberOfRows As Int					: NumberOfRows = 0";
_numberofrows = 0;
 //BA.debugLineNum = 15;BA.debugLine="Dim NumberOfRows As Int					: NumberOfRows = 0";
_numberofrows = (int)(0);
 //BA.debugLineNum = 16;BA.debugLine="Dim NumberOfVisibleRows As Int";
_numberofvisiblerows = 0;
 //BA.debugLineNum = 17;BA.debugLine="Dim RowHeight As Int						: RowHeight = 30dip";
_rowheight = 0;
 //BA.debugLineNum = 17;BA.debugLine="Dim RowHeight As Int						: RowHeight = 30dip";
_rowheight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30));
 //BA.debugLineNum = 18;BA.debugLine="Dim RowLineWidth As Int					: RowLineWidth = 1dip";
_rowlinewidth = 0;
 //BA.debugLineNum = 18;BA.debugLine="Dim RowLineWidth As Int					: RowLineWidth = 1dip";
_rowlinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 19;BA.debugLine="Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth";
_rowheight_1 = 0;
 //BA.debugLineNum = 19;BA.debugLine="Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth";
_rowheight_1 = (int)(_rowheight-_rowlinewidth);
 //BA.debugLineNum = 20;BA.debugLine="Dim ColLineWidth As Int					: ColLineWidth = 1dip";
_collinewidth = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim ColLineWidth As Int					: ColLineWidth = 1dip";
_collinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 21;BA.debugLine="Dim ColumnWidth(NumberOfColumns) As Int";
_columnwidth = new int[_numberofcolumns];
;
 //BA.debugLineNum = 22;BA.debugLine="ColumnWidth(0) = 50dip";
_columnwidth[(int)(0)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50));
 //BA.debugLineNum = 23;BA.debugLine="ColumnWidth(1) = 100dip";
_columnwidth[(int)(1)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 24;BA.debugLine="ColumnWidth(2) = 100dip";
_columnwidth[(int)(2)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 25;BA.debugLine="ColumnWidth(3) = 150dip";
_columnwidth[(int)(3)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(150));
 //BA.debugLineNum = 26;BA.debugLine="ColumnWidth(4) = 100dip";
_columnwidth[(int)(4)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 27;BA.debugLine="Dim ColumnWidth_1(NumberOfColumns) As Int";
_columnwidth_1 = new int[_numberofcolumns];
;
 //BA.debugLineNum = 28;BA.debugLine="Dim TotalColumnWidth(NumberOfColumns + 1) As Int";
_totalcolumnwidth = new int[(int)(_numberofcolumns+1)];
;
 //BA.debugLineNum = 31;BA.debugLine="Dim ColumnName(NumberOfColumns) As String	' names of the columns";
_columnname = new String[_numberofcolumns];
java.util.Arrays.fill(_columnname,"");
 //BA.debugLineNum = 32;BA.debugLine="ColumnName(0) = \"ID\"";
_columnname[(int)(0)] = "ID";
 //BA.debugLineNum = 33;BA.debugLine="ColumnName(1) = \"FirstName\"";
_columnname[(int)(1)] = "FirstName";
 //BA.debugLineNum = 34;BA.debugLine="ColumnName(2) = \"LastName\"";
_columnname[(int)(2)] = "LastName";
 //BA.debugLineNum = 35;BA.debugLine="ColumnName(3) = \"Address\"";
_columnname[(int)(3)] = "Address";
 //BA.debugLineNum = 36;BA.debugLine="ColumnName(4) = \"City\"";
_columnname[(int)(4)] = "City";
 //BA.debugLineNum = 37;BA.debugLine="Dim ColumnToSort As String			: ColumnToSort = 0		' index of the column to sort";
_columntosort = "";
 //BA.debugLineNum = 37;BA.debugLine="Dim ColumnToSort As String			: ColumnToSort = 0		' index of the column to sort";
_columntosort = BA.NumberToString(0);
 //BA.debugLineNum = 38;BA.debugLine="Dim Filter As Boolean						: Filter = False			' flag for the filter function";
_filter = false;
 //BA.debugLineNum = 38;BA.debugLine="Dim Filter As Boolean						: Filter = False			' flag for the filter function";
_filter = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 39;BA.debugLine="Dim FilterType As String				: FilterType = \"AND\"	' variable for the filter AND / OR";
_filtertype = "";
 //BA.debugLineNum = 39;BA.debugLine="Dim FilterType As String				: FilterType = \"AND\"	' variable for the filter AND / OR";
_filtertype = "AND";
 //BA.debugLineNum = 40;BA.debugLine="Dim SortDirection(NumberOfColumns) As String					' sort direction for the columns";
_sortdirection = new String[_numberofcolumns];
java.util.Arrays.fill(_sortdirection,"");
 //BA.debugLineNum = 43;BA.debugLine="Dim HeaderColor As Int					: HeaderColor = Colors.Blue";
_headercolor = 0;
 //BA.debugLineNum = 43;BA.debugLine="Dim HeaderColor As Int					: HeaderColor = Colors.Blue";
_headercolor = anywheresoftware.b4a.keywords.Common.Colors.Blue;
 //BA.debugLineNum = 44;BA.debugLine="Dim HeaderFontColor As Int			: HeaderFontColor = Colors.Yellow";
_headerfontcolor = 0;
 //BA.debugLineNum = 44;BA.debugLine="Dim HeaderFontColor As Int			: HeaderFontColor = Colors.Yellow";
_headerfontcolor = anywheresoftware.b4a.keywords.Common.Colors.Yellow;
 //BA.debugLineNum = 45;BA.debugLine="Dim HeaderLineColor As Int			: HeaderLineColor = Colors.Yellow";
_headerlinecolor = 0;
 //BA.debugLineNum = 45;BA.debugLine="Dim HeaderLineColor As Int			: HeaderLineColor = Colors.Yellow";
_headerlinecolor = anywheresoftware.b4a.keywords.Common.Colors.Yellow;
 //BA.debugLineNum = 46;BA.debugLine="Dim LineColor As Int						: LineColor = Colors.Black";
_linecolor = 0;
 //BA.debugLineNum = 46;BA.debugLine="Dim LineColor As Int						: LineColor = Colors.Black";
_linecolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 47;BA.debugLine="Dim CellColor As Int						: CellColor = Colors.RGB(255,255,220)";
_cellcolor = 0;
 //BA.debugLineNum = 47;BA.debugLine="Dim CellColor As Int						: CellColor = Colors.RGB(255,255,220)";
_cellcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(255),(int)(220));
 //BA.debugLineNum = 48;BA.debugLine="Dim FontColor As Int						: FontColor = Colors.Black";
_fontcolor = 0;
 //BA.debugLineNum = 48;BA.debugLine="Dim FontColor As Int						: FontColor = Colors.Black";
_fontcolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 49;BA.debugLine="Dim FontSize As Float						: FontSize = 14";
_fontsize = 0f;
 //BA.debugLineNum = 49;BA.debugLine="Dim FontSize As Float						: FontSize = 14";
_fontsize = (float)(14);
 //BA.debugLineNum = 50;BA.debugLine="Dim Alignment As Int						: Alignment = Gravity.CENTER";
_alignment = 0;
 //BA.debugLineNum = 50;BA.debugLine="Dim Alignment As Int						: Alignment = Gravity.CENTER";
_alignment = anywheresoftware.b4a.keywords.Common.Gravity.CENTER;
 //BA.debugLineNum = 51;BA.debugLine="Dim SelectedRow As Int					: SelectedRow = -1";
_selectedrow = 0;
 //BA.debugLineNum = 51;BA.debugLine="Dim SelectedRow As Int					: SelectedRow = -1";
_selectedrow = (int)(-1);
 //BA.debugLineNum = 52;BA.debugLine="Dim SelectedRowColor As Int			: SelectedRowColor=Colors.RGB(255,196,255)";
_selectedrowcolor = 0;
 //BA.debugLineNum = 52;BA.debugLine="Dim SelectedRowColor As Int			: SelectedRowColor=Colors.RGB(255,196,255)";
_selectedrowcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(196),(int)(255));
 //BA.debugLineNum = 53;BA.debugLine="Dim SelectedCellColor As Int		: SelectedCellColor=Colors.RGB(255,150,255)";
_selectedcellcolor = 0;
 //BA.debugLineNum = 53;BA.debugLine="Dim SelectedCellColor As Int		: SelectedCellColor=Colors.RGB(255,150,255)";
_selectedcellcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(150),(int)(255));
 //BA.debugLineNum = 54;BA.debugLine="Type RowCol (Row As Int, Col As Int)";
;
 //BA.debugLineNum = 55;BA.debugLine="Dim MoveLeft0, MoveX0, MoveX1, DeltaScroll, DeltaX As Float";
_moveleft0 = 0f;
_movex0 = 0f;
_movex1 = 0f;
_deltascroll = 0f;
_deltax = 0f;
 //BA.debugLineNum = 56;BA.debugLine="Dim Time0 As Long";
_time0 = 0L;
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _selectrow(main._rowcol _rc) throws Exception{
		Debug.PushSubsStack("SelectRow (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _col = 0;
Debug.locals.put("rc", _rc);
 BA.debugLineNum = 236;BA.debugLine="Sub SelectRow(rc As RowCol)";
Debug.ShouldStop(2048);
 BA.debugLineNum = 237;BA.debugLine="Dim col As Int";
Debug.ShouldStop(4096);
_col = 0;Debug.locals.put("col", _col);
 BA.debugLineNum = 240;BA.debugLine="If SelectedRow > -1 Then";
Debug.ShouldStop(32768);
if (_selectedrow>-1) { 
 BA.debugLineNum = 241;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(65536);
{
final double step204 = 1;
final double limit204 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step204 > 0 && _col <= limit204) || (step204 < 0 && _col >= limit204); _col += step204) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 242;BA.debugLine="GetView(SelectedRow, col).Color = CellColor";
Debug.ShouldStop(131072);
_getview(_selectedrow,_col).setColor(_cellcolor);
 }
}Debug.locals.put("col", _col);
;
 };
 BA.debugLineNum = 246;BA.debugLine="SelectedRow = rc.Row";
Debug.ShouldStop(2097152);
_selectedrow = _rc.Row;
 BA.debugLineNum = 249;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(16777216);
{
final double step209 = 1;
final double limit209 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step209 > 0 && _col <= limit209) || (step209 < 0 && _col >= limit209); _col += step209) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 250;BA.debugLine="If col = rc.col Then";
Debug.ShouldStop(33554432);
if (_col==_rc.Col) { 
 BA.debugLineNum = 251;BA.debugLine="GetView(rc.Row, col).Color = SelectedCellColor";
Debug.ShouldStop(67108864);
_getview(_rc.Row,_col).setColor(_selectedcellcolor);
 }else {
 BA.debugLineNum = 253;BA.debugLine="GetView(rc.Row, col).Color = SelectedRowColor";
Debug.ShouldStop(268435456);
_getview(_rc.Row,_col).setColor(_selectedrowcolor);
 };
 }
}Debug.locals.put("col", _col);
;
 BA.debugLineNum = 257;BA.debugLine="If SelectedRow > -1 Then";
Debug.ShouldStop(1);
if (_selectedrow>-1) { 
 BA.debugLineNum = 258;BA.debugLine="btnEdit.Visible = True";
Debug.ShouldStop(2);
mostCurrent._btnedit.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 259;BA.debugLine="btnDelete.Visible = True";
Debug.ShouldStop(4);
mostCurrent._btndelete.setVisible(anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 261;BA.debugLine="btnEdit.Visible = False";
Debug.ShouldStop(16);
mostCurrent._btnedit.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 262;BA.debugLine="btnDelete.Visible = False";
Debug.ShouldStop(32);
mostCurrent._btndelete.setVisible(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 264;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _setcell(int _row,int _col,String _value) throws Exception{
		Debug.PushSubsStack("SetCell (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 329;BA.debugLine="Sub SetCell(Row As Int, Col As Int, Value As String)";
Debug.ShouldStop(256);
 BA.debugLineNum = 331;BA.debugLine="GetView(Row, Col).Text = Value";
Debug.ShouldStop(1024);
_getview(_row,_col).setText((Object)(_value));
 BA.debugLineNum = 332;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _setheader(String[] _values) throws Exception{
		Debug.PushSubsStack("SetHeader (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
Debug.locals.put("Values", _values);
 BA.debugLineNum = 301;BA.debugLine="Sub SetHeader(Values() As String)";
Debug.ShouldStop(4096);
 BA.debugLineNum = 303;BA.debugLine="If pnlHeader.IsInitialized Then 'should only be called once";
Debug.ShouldStop(16384);
if (mostCurrent._pnlheader.IsInitialized()) { 
 BA.debugLineNum = 304;BA.debugLine="Return";
Debug.ShouldStop(32768);
if (true) return "";
 };
 BA.debugLineNum = 307;BA.debugLine="pnlHeader.Initialize(\"\")";
Debug.ShouldStop(262144);
mostCurrent._pnlheader.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 308;BA.debugLine="pnlHeader.Color = HeaderLineColor";
Debug.ShouldStop(524288);
mostCurrent._pnlheader.setColor(_headerlinecolor);
 BA.debugLineNum = 310;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(2097152);
{
final double step258 = 1;
final double limit258 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step258 > 0 && _i <= limit258) || (step258 < 0 && _i >= limit258); _i += step258) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 311;BA.debugLine="Dim l As Label";
Debug.ShouldStop(4194304);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 312;BA.debugLine="l.Initialize(\"Header\")";
Debug.ShouldStop(8388608);
_l.Initialize(mostCurrent.activityBA,"Header");
 BA.debugLineNum = 313;BA.debugLine="If SortDirection(i) = \"ASC\" Then";
Debug.ShouldStop(16777216);
if ((_sortdirection[_i]).equals("ASC")) { 
 BA.debugLineNum = 314;BA.debugLine="l.Text = Values(i) & \" ↓\"";
Debug.ShouldStop(33554432);
_l.setText((Object)(_values[_i]+" ↓"));
 }else {
 BA.debugLineNum = 316;BA.debugLine="l.Text = Values(i) & \" ↑\"";
Debug.ShouldStop(134217728);
_l.setText((Object)(_values[_i]+" ↑"));
 };
 BA.debugLineNum = 318;BA.debugLine="l.Text = Values(i)";
Debug.ShouldStop(536870912);
_l.setText((Object)(_values[_i]));
 BA.debugLineNum = 319;BA.debugLine="l.Gravity = Gravity.CENTER";
Debug.ShouldStop(1073741824);
_l.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 320;BA.debugLine="l.TextSize = FontSize";
Debug.ShouldStop(-2147483648);
_l.setTextSize(_fontsize);
 BA.debugLineNum = 321;BA.debugLine="l.Color = HeaderColor";
Debug.ShouldStop(1);
_l.setColor(_headercolor);
 BA.debugLineNum = 322;BA.debugLine="l.TextColor = HeaderFontColor";
Debug.ShouldStop(2);
_l.setTextColor(_headerfontcolor);
 BA.debugLineNum = 323;BA.debugLine="l.Tag = i";
Debug.ShouldStop(4);
_l.setTag((Object)(_i));
 BA.debugLineNum = 324;BA.debugLine="pnlHeader.AddView(l, TotalColumnWidth(i), 0, ColumnWidth_1(i), RowHeight_1)";
Debug.ShouldStop(8);
mostCurrent._pnlheader.AddView((android.view.View)(_l.getObject()),_totalcolumnwidth[_i],(int)(0),_columnwidth_1[_i],_rowheight_1);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 326;BA.debugLine="Activity.AddView(pnlHeader, scvPersons.Left, 0, scvPersons.Width, RowHeight)";
Debug.ShouldStop(32);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlheader.getObject()),mostCurrent._scvpersons.getLeft(),(int)(0),mostCurrent._scvpersons.getWidth(),_rowheight);
 BA.debugLineNum = 327;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _skbscroll_valuechanged(int _value,boolean _userchanged) throws Exception{
		Debug.PushSubsStack("skbScroll_ValueChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Value", _value);
Debug.locals.put("UserChanged", _userchanged);
 BA.debugLineNum = 348;BA.debugLine="Sub skbScroll_ValueChanged (Value As Int, UserChanged As Boolean)";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 350;BA.debugLine="pnlHeader.Left = - Value";
Debug.ShouldStop(536870912);
mostCurrent._pnlheader.setLeft((int)(-_value));
 BA.debugLineNum = 351;BA.debugLine="scvPersons.Left = - Value";
Debug.ShouldStop(1073741824);
mostCurrent._scvpersons.setLeft((int)(-_value));
 BA.debugLineNum = 352;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _sqltableread() throws Exception{
		Debug.PushSubsStack("SQLTableRead (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
String _txt = "";
String _wtxt = "";
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
String[] _col = null;
int _j = 0;
 BA.debugLineNum = 402;BA.debugLine="Sub SQLTableRead";
Debug.ShouldStop(131072);
 BA.debugLineNum = 404;BA.debugLine="Dim i As Int";
Debug.ShouldStop(524288);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 405;BA.debugLine="Dim Cursor1 As Cursor";
Debug.ShouldStop(1048576);
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();Debug.locals.put("Cursor1", _cursor1);
 BA.debugLineNum = 406;BA.debugLine="Dim txt, wtxt As String";
Debug.ShouldStop(2097152);
_txt = "";Debug.locals.put("txt", _txt);
_wtxt = "";Debug.locals.put("wtxt", _wtxt);
 BA.debugLineNum = 408;BA.debugLine="ClearAll";
Debug.ShouldStop(8388608);
_clearall();
 BA.debugLineNum = 410;BA.debugLine="txt = \"SELECT * FROM \" & DBTableName";
Debug.ShouldStop(33554432);
_txt = "SELECT * FROM "+_dbtablename;Debug.locals.put("txt", _txt);
 BA.debugLineNum = 412;BA.debugLine="If Filter = True Then";
Debug.ShouldStop(134217728);
if (_filter==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 413;BA.debugLine="wtxt = \"\"";
Debug.ShouldStop(268435456);
_wtxt = "";Debug.locals.put("wtxt", _wtxt);
 BA.debugLineNum = 414;BA.debugLine="For i = 1 To NumberOfColumns - 1";
Debug.ShouldStop(536870912);
{
final double step343 = 1;
final double limit343 = (int)(_numberofcolumns-1);
for (_i = (int)(1); (step343 > 0 && _i <= limit343) || (step343 < 0 && _i >= limit343); _i += step343) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 415;BA.debugLine="Dim e As EditText";
Debug.ShouldStop(1073741824);
_e = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("e", _e);
 BA.debugLineNum = 416;BA.debugLine="e.Initialize(\"\")";
Debug.ShouldStop(-2147483648);
_e.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 417;BA.debugLine="e = scvFilter.Panel.GetView((i - 1) * 2 + 1)";
Debug.ShouldStop(1);
_e.setObject((android.widget.EditText)(mostCurrent._scvfilter.getPanel().GetView((int)((_i-1)*2+1)).getObject()));
 BA.debugLineNum = 418;BA.debugLine="If e.Text<>\"\" Then";
Debug.ShouldStop(2);
if ((_e.getText()).equals("") == false) { 
 BA.debugLineNum = 419;BA.debugLine="If wtxt = \"\" Then";
Debug.ShouldStop(4);
if ((_wtxt).equals("")) { 
 BA.debugLineNum = 420;BA.debugLine="wtxt = wtxt & ColumnName(i) & \" LIKE '\" & e.Text & \"'\"";
Debug.ShouldStop(8);
_wtxt = _wtxt+_columnname[_i]+" LIKE '"+_e.getText()+"'";Debug.locals.put("wtxt", _wtxt);
 }else {
 BA.debugLineNum = 422;BA.debugLine="wtxt=wtxt&\" \"&FilterType&\" \"&ColumnName(i)& \" LIKE '\"&e.Text&\"'\"";
Debug.ShouldStop(32);
_wtxt = _wtxt+" "+_filtertype+" "+_columnname[_i]+" LIKE '"+_e.getText()+"'";Debug.locals.put("wtxt", _wtxt);
 };
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 426;BA.debugLine="If wtxt <> \"\" Then";
Debug.ShouldStop(512);
if ((_wtxt).equals("") == false) { 
 BA.debugLineNum = 427;BA.debugLine="txt = txt & \" WHERE \" & wtxt";
Debug.ShouldStop(1024);
_txt = _txt+" WHERE "+_wtxt;Debug.locals.put("txt", _txt);
 };
 };
 BA.debugLineNum = 430;BA.debugLine="txt=txt&\" ORDER BY \"&ColumnName(ColumnToSort)& \" \"&SortDirection(ColumnToSort)";
Debug.ShouldStop(8192);
_txt = _txt+" ORDER BY "+_columnname[(int)(Double.parseDouble(_columntosort))]+" "+_sortdirection[(int)(Double.parseDouble(_columntosort))];Debug.locals.put("txt", _txt);
 BA.debugLineNum = 432;BA.debugLine="Cursor1 = SQL1.ExecQuery(txt)";
Debug.ShouldStop(32768);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery(_txt)));
 BA.debugLineNum = 434;BA.debugLine="Dim Col(NumberOfColumns) As String";
Debug.ShouldStop(131072);
_col = new String[_numberofcolumns];
java.util.Arrays.fill(_col,"");Debug.locals.put("Col", _col);
 BA.debugLineNum = 436;BA.debugLine="SetHeader(ColumnName)";
Debug.ShouldStop(524288);
_setheader(_columnname);
 BA.debugLineNum = 437;BA.debugLine="NumberOfRows = 0";
Debug.ShouldStop(1048576);
_numberofrows = (int)(0);
 BA.debugLineNum = 439;BA.debugLine="For i = 0 To Cursor1.RowCount - 1";
Debug.ShouldStop(4194304);
{
final double step364 = 1;
final double limit364 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step364 > 0 && _i <= limit364) || (step364 < 0 && _i >= limit364); _i += step364) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 440;BA.debugLine="Dim Col(NumberOfColumns) As String";
Debug.ShouldStop(8388608);
_col = new String[_numberofcolumns];
java.util.Arrays.fill(_col,"");Debug.locals.put("Col", _col);
 BA.debugLineNum = 441;BA.debugLine="Cursor1.Position = i";
Debug.ShouldStop(16777216);
_cursor1.setPosition(_i);
 BA.debugLineNum = 442;BA.debugLine="For j = 0 To NumberOfColumns - 1";
Debug.ShouldStop(33554432);
{
final double step367 = 1;
final double limit367 = (int)(_numberofcolumns-1);
for (_j = (int)(0); (step367 > 0 && _j <= limit367) || (step367 < 0 && _j >= limit367); _j += step367) {
Debug.locals.put("j", _j);
 BA.debugLineNum = 443;BA.debugLine="Col(j) = Cursor1.GetString(ColumnName(j))";
Debug.ShouldStop(67108864);
_col[_j] = _cursor1.GetString(_columnname[_j]);Debug.locals.put("Col", _col);
 }
}Debug.locals.put("j", _j);
;
 BA.debugLineNum = 445;BA.debugLine="AddRow(Col)";
Debug.ShouldStop(268435456);
_addrow(_col);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 447;BA.debugLine="Cursor1.Close";
Debug.ShouldStop(1073741824);
_cursor1.Close();
 BA.debugLineNum = 448;BA.debugLine="Activity.Title = DBFileName";
Debug.ShouldStop(-2147483648);
mostCurrent._activity.setTitle((Object)(_dbfilename));
 BA.debugLineNum = 449;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _timer1_tick() throws Exception{
		Debug.PushSubsStack("Timer1_Tick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
float _left = 0f;
 BA.debugLineNum = 380;BA.debugLine="Sub Timer1_Tick";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 381;BA.debugLine="Dim Left As Float";
Debug.ShouldStop(268435456);
_left = 0f;Debug.locals.put("Left", _left);
 BA.debugLineNum = 383;BA.debugLine="Left = scvPersons.Left + DeltaScroll";
Debug.ShouldStop(1073741824);
_left = (float)(mostCurrent._scvpersons.getLeft()+_deltascroll);Debug.locals.put("Left", _left);
 BA.debugLineNum = 384;BA.debugLine="If Left > 0 Then";
Debug.ShouldStop(-2147483648);
if (_left>0) { 
 BA.debugLineNum = 385;BA.debugLine="Left = 0";
Debug.ShouldStop(1);
_left = (float)(0);Debug.locals.put("Left", _left);
 BA.debugLineNum = 386;BA.debugLine="Timer1.Enabled = False";
Debug.ShouldStop(2);
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 388;BA.debugLine="If Left < -(TotalColumnWidth(NumberOfColumns) - Activity.Width) Then";
Debug.ShouldStop(8);
if (_left<-(_totalcolumnwidth[_numberofcolumns]-mostCurrent._activity.getWidth())) { 
 BA.debugLineNum = 389;BA.debugLine="Left = -(TotalColumnWidth(NumberOfColumns) - Activity.Width)";
Debug.ShouldStop(16);
_left = (float)(-(_totalcolumnwidth[_numberofcolumns]-mostCurrent._activity.getWidth()));Debug.locals.put("Left", _left);
 BA.debugLineNum = 390;BA.debugLine="Timer1.Enabled = False";
Debug.ShouldStop(32);
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 393;BA.debugLine="scvPersons.Left = Left";
Debug.ShouldStop(256);
mostCurrent._scvpersons.setLeft((int)(_left));
 BA.debugLineNum = 394;BA.debugLine="pnlHeader.Left = Left";
Debug.ShouldStop(512);
mostCurrent._pnlheader.setLeft((int)(_left));
 BA.debugLineNum = 396;BA.debugLine="DeltaScroll = DeltaScroll / 1.2";
Debug.ShouldStop(2048);
_deltascroll = (float)(_deltascroll/(double)1.2);
 BA.debugLineNum = 397;BA.debugLine="If Abs(DeltaScroll) < 5dip Then";
Debug.ShouldStop(4096);
if (anywheresoftware.b4a.keywords.Common.Abs(_deltascroll)<anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5))) { 
 BA.debugLineNum = 398;BA.debugLine="Timer1.Enabled = False";
Debug.ShouldStop(8192);
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 400;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"ProgName",_progname,"ProgVersion",_progversion,"SQL1",_sql1,"DBFileName",_dbfilename,"DBFileDir",_dbfiledir,"DBTableName",_dbtablename,"NumberOfColumns",_numberofcolumns,"NumberOfRows",_numberofrows,"NumberOfVisibleRows",_numberofvisiblerows,"RowHeight",_rowheight,"RowLineWidth",_rowlinewidth,"RowHeight_1",_rowheight_1,"ColLineWidth",_collinewidth,"ColumnWidth",_columnwidth,"ColumnWidth_1",_columnwidth_1,"TotalColumnWidth",_totalcolumnwidth,"ColumnName",_columnname,"ColumnToSort",_columntosort,"Filter",_filter,"FilterType",_filtertype,"SortDirection",_sortdirection,"HeaderColor",_headercolor,"HeaderFontColor",_headerfontcolor,"HeaderLineColor",_headerlinecolor,"LineColor",_linecolor,"CellColor",_cellcolor,"FontColor",_fontcolor,"FontSize",_fontsize,"Alignment",_alignment,"SelectedRow",_selectedrow,"SelectedRowColor",_selectedrowcolor,"SelectedCellColor",_selectedcellcolor,"MoveLeft0",_moveleft0,"MoveX0",_movex0,"MoveX1",_movex1,"DeltaScroll",_deltascroll,"DeltaX",_deltax,"Time0",_time0,"scvPersons",_scvpersons,"scvEdit",_scvedit,"scvFilter",_scvfilter,"pnlToolBox",_pnltoolbox,"pnlEdit",_pnledit,"pnlEditTools",_pnledittools,"pnlFilter",_pnlfilter,"pnlFilterTools",_pnlfiltertools,"btnEditAdd",_btneditadd,"btnDelete",_btndelete,"btnEdit",_btnedit,"btnEditModif",_btneditmodif,"btnEditMove",_btneditmove,"btnLoad",_btnload,"btnFilter",_btnfilter,"btnFilterGo",_btnfiltergo,"btnFilterAND",_btnfilterand,"btnFilterOR",_btnfilteror,"btnFilterType",_btnfiltertype,"pnlHeader",_pnlheader,"skbScroll",_skbscroll,"pnlScroll",_pnlscroll,"Timer1",_timer1,"LHeight",_lheight,"EHeight",_eheight,"THeight",_theight};
}
}
